/***********************************************************
*                       pC/TFS 2.38b                       *
*                 a FREE - Tiny File System                *
*                                                          *
*           by Frank Goetze  -  www.embedded-os.de         *
************************************************************
*                      TFS_Port_RAM.c                      *
*                      RAM test Port                       *
************************************************************
* Revision-Info:                                           *
*                                                          *
***********************************************************/

#include "../../inc/RAM/TFS_Port_RAM.h"

#ifndef TFS_START                                          // if no (compiler unknown) TFS-area defined ...
 U08 TFS_START[TFS_SIZE];                                  // ... create an array
#endif
/*
************************************************************
*                    INIT MEMORY
************************************************************
*/
U08 TFSPort_Init(void)
{
    return(TFS_NO_ERR);                                    // nothing to init here
}

/*
************************************************************
*                    WRITE INTO RAM
************************************************************
*/
U08 TFSPort_Write(U08 OS_HUGE *dest, OS_CONST U08 OS_HUGE *source, TFS_LONG length) KC51_REENTRANT
{
    TFS_LONG byte;

    if((source >= (U08 OS_HUGE *)TFS_START) && (source < ((U08 OS_HUGE *)(TFS_START) + TFS_SIZE)))
        return(TFS_WR_PTR);                                // ERROR - source is in TFS-area
    if((dest < (U08 OS_HUGE *)TFS_START) || ((dest + length) > ((U08 OS_HUGE *)(TFS_START) + TFS_SIZE)))
        return(TFS_WR_PTR);                                // ERROR - destination is not in TFS-area
    for(byte = 0; byte < length; byte++)
        dest[byte] = source[byte];                         // write bytes
    return(TFS_NO_ERR);
}

/*
************************************************************
*                        FILL RAM
************************************************************
*/
U08 TFSPort_Fill(U08 OS_HUGE *dest, U08 value, TFS_LONG length) KC51_REENTRANT
{
    TFS_LONG byte;

    if((dest < (U08 OS_HUGE *)TFS_START) || ((dest + length) > ((U08 OS_HUGE *)(TFS_START) + TFS_SIZE)))
        return(TFS_WR_PTR);                                // ERROR - destination is not in TFS-area
    for(byte = 0; byte < length; byte++)
        dest[byte] = value;                                // fill with value
    return(TFS_NO_ERR);
}

/**********************************************************/
